BitSensor = require('bitsensor-node-js');
BitSensor.config(require('./config.json'));

const express = require('express');
const cookieParser = require('cookie-parser');
const bodyParser = require('body-parser');
const session = require('express-session');

const app = express();
app.use(bodyParser.json());
app.use(cookieParser());
app.use(session({
  secret: 'm4F3ePd452Ds45GdvnwDfe35gF',
  saveUninitialized: true,
  resave: true
}));

// BITSENSOR
app.use(BitSensor.MiddlewareExpress.startTrace);

app.get('/', function (req, res, next) {
  res.send('approved');
  next();
});
app.get('/err', function () {
  throw new Error('ok');
});

// BITSENSOR
app.use(BitSensor.MiddlewareExpress.stopTrace);

app.set('port', 3003);

const server = app.listen(app.get('port'), function () {
  console.log('Server started on port ' + app.get('port'));
});

module.exports = {
  app,
  server
};